using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Text;

namespace HierarchicalDataControlLibrarySample
{
    // Sample node class.
    public class MyNode : INotifyPropertyChanged
    {
        public MyNode()
        {
            Expanded = true;
            Indent = 0;
            Image = 0;
        }

        public MyNode(int id, string name, string description, bool expanded, int indent, int imageIndex)
        {
            ID = id;
            Name = name;
            Description = description;
            Expanded = expanded;
            Indent = indent;
            Image = imageIndex;
        }

        private int id;
        public int ID
        {
            get { return id; }
            set { id = value; propertyChanged("ID"); }
        }

        private string name;
        public string Name
        {
            get { return name; }
            set { name = value; propertyChanged("Name"); }
        }

        private string description;
        public string Description
        {
            get { return description; }
            set { description = value; propertyChanged("Description"); }
        }

        private bool expanded;
        public bool Expanded
        {
            get { return expanded; }
            set { expanded = value; propertyChanged("Expanded"); }
        }

        private int indent;
        public int Indent
        {
            get { return indent; }
            set { indent = value; propertyChanged("Indent"); }
        }

        private int image;
        public int Image
        {
            get { return image; }
            set { image = value; propertyChanged("Image"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void propertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
